<?php

namespace Models\Docdata\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for cancelSuccess StructType
 * @subpackage Structs
 */
class CancelSuccess extends AbstractStructBase
{
    /**
     * The success
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \Models\Docdata\StructType\Success
     */
    public $success;
    /**
     * The result
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $result;
    /**
     * The any
     * @var \DOMDocument
     */
    public $any;
    /**
     * Constructor method for cancelSuccess
     * @uses CancelSuccess::setSuccess()
     * @uses CancelSuccess::setResult()
     * @uses CancelSuccess::setAny()
     * @param \Models\Docdata\StructType\Success $success
     * @param string $result
     * @param \DOMDocument $any
     */
    public function __construct(\Models\Docdata\StructType\Success $success = null, $result = null, \DOMDocument $any = null)
    {
        $this
            ->setSuccess($success)
            ->setResult($result)
            ->setAny($any);
    }
    /**
     * Get success value
     * @return \Models\Docdata\StructType\Success
     */
    public function getSuccess()
    {
        return $this->success;
    }
    /**
     * Set success value
     * @param \Models\Docdata\StructType\Success $success
     * @return \Models\Docdata\StructType\CancelSuccess
     */
    public function setSuccess(\Models\Docdata\StructType\Success $success = null)
    {
        $this->success = $success;
        return $this;
    }
    /**
     * Get result value
     * @return string
     */
    public function getResult()
    {
        return $this->result;
    }
    /**
     * Set result value
     * @uses \Models\Docdata\EnumType\CancelResult::valueIsValid()
     * @uses \Models\Docdata\EnumType\CancelResult::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $result
     * @return \Models\Docdata\StructType\CancelSuccess
     */
    public function setResult($result = null)
    {
        // validation for constraint: enumeration
        if (!\Models\Docdata\EnumType\CancelResult::valueIsValid($result)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $result, implode(', ', \Models\Docdata\EnumType\CancelResult::getValidValues())), __LINE__);
        }
        $this->result = $result;
        return $this;
    }
    /**
     * Get any value
     * @uses \DOMDocument::loadXML()
     * @uses \DOMDocument::hasChildNodes()
     * @uses \DOMDocument::saveXML()
     * @uses \DOMNode::item()
     * @uses \Models\Docdata\StructType\CancelSuccess::setAny()
     * @param bool $asString true: returns XML string, false: returns \DOMDocument
     * @return \DOMDocument|null
     */
    public function getAny($asString = true)
    {
        if (!empty($this->any) && !($this->any instanceof \DOMDocument)) {
            $dom = new \DOMDocument('1.0', 'UTF-8');
            $dom->formatOutput = true;
            if ($dom->loadXML($this->any)) {
                $this->setAny($dom);
            }
            unset($dom);
        }
        return ($asString && ($this->any instanceof \DOMDocument) && $this->any->hasChildNodes()) ? $this->any->saveXML($this->any->childNodes->item(0)) : $this->any;
    }
    /**
     * Set any value
     * @param \DOMDocument $any
     * @return \Models\Docdata\StructType\CancelSuccess
     */
    public function setAny(\DOMDocument $any = null)
    {
        $this->any = $any;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Models\Docdata\StructType\CancelSuccess
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
