<?php

namespace Models\Docdata\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for paymentResponse StructType
 * Meta informations extracted from the WSDL
 * - documentation: Only present when there was a paymentRequest element in the request.
 * @subpackage Structs
 */
class PaymentResponse extends AbstractStructBase
{
    /**
     * The paymentSuccess
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Models\Docdata\StructType\PaymentSuccess
     */
    public $paymentSuccess;
    /**
     * The paymentInsufficientData
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var mixed
     */
    public $paymentInsufficientData;
    /**
     * The paymentError
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Models\Docdata\StructType\PaymentError
     */
    public $paymentError;
    /**
     * The any
     * @var \DOMDocument
     */
    public $any;
    /**
     * Constructor method for paymentResponse
     * @uses PaymentResponse::setPaymentSuccess()
     * @uses PaymentResponse::setPaymentInsufficientData()
     * @uses PaymentResponse::setPaymentError()
     * @uses PaymentResponse::setAny()
     * @param \Models\Docdata\StructType\PaymentSuccess $paymentSuccess
     * @param mixed $paymentInsufficientData
     * @param \Models\Docdata\StructType\PaymentError $paymentError
     * @param \DOMDocument $any
     */
    public function __construct(\Models\Docdata\StructType\PaymentSuccess $paymentSuccess = null, $paymentInsufficientData = null, \Models\Docdata\StructType\PaymentError $paymentError = null, \DOMDocument $any = null)
    {
        $this
            ->setPaymentSuccess($paymentSuccess)
            ->setPaymentInsufficientData($paymentInsufficientData)
            ->setPaymentError($paymentError)
            ->setAny($any);
    }
    /**
     * Get paymentSuccess value
     * @return \Models\Docdata\StructType\PaymentSuccess|null
     */
    public function getPaymentSuccess()
    {
        return $this->paymentSuccess;
    }
    /**
     * Set paymentSuccess value
     * @param \Models\Docdata\StructType\PaymentSuccess $paymentSuccess
     * @return \Models\Docdata\StructType\PaymentResponse
     */
    public function setPaymentSuccess(\Models\Docdata\StructType\PaymentSuccess $paymentSuccess = null)
    {
        $this->paymentSuccess = $paymentSuccess;
        return $this;
    }
    /**
     * Get paymentInsufficientData value
     * @return mixed|null
     */
    public function getPaymentInsufficientData()
    {
        return $this->paymentInsufficientData;
    }
    /**
     * Set paymentInsufficientData value
     * @param mixed $paymentInsufficientData
     * @return \Models\Docdata\StructType\PaymentResponse
     */
    public function setPaymentInsufficientData($paymentInsufficientData = null)
    {
        $this->paymentInsufficientData = $paymentInsufficientData;
        return $this;
    }
    /**
     * Get paymentError value
     * @return \Models\Docdata\StructType\PaymentError|null
     */
    public function getPaymentError()
    {
        return $this->paymentError;
    }
    /**
     * Set paymentError value
     * @param \Models\Docdata\StructType\PaymentError $paymentError
     * @return \Models\Docdata\StructType\PaymentResponse
     */
    public function setPaymentError(\Models\Docdata\StructType\PaymentError $paymentError = null)
    {
        $this->paymentError = $paymentError;
        return $this;
    }
    /**
     * Get any value
     * @uses \DOMDocument::loadXML()
     * @uses \DOMDocument::hasChildNodes()
     * @uses \DOMDocument::saveXML()
     * @uses \DOMNode::item()
     * @uses \Models\Docdata\StructType\PaymentResponse::setAny()
     * @param bool $asString true: returns XML string, false: returns \DOMDocument
     * @return \DOMDocument|null
     */
    public function getAny($asString = true)
    {
        if (!empty($this->any) && !($this->any instanceof \DOMDocument)) {
            $dom = new \DOMDocument('1.0', 'UTF-8');
            $dom->formatOutput = true;
            if ($dom->loadXML($this->any)) {
                $this->setAny($dom);
            }
            unset($dom);
        }
        return ($asString && ($this->any instanceof \DOMDocument) && $this->any->hasChildNodes()) ? $this->any->saveXML($this->any->childNodes->item(0)) : $this->any;
    }
    /**
     * Set any value
     * @param \DOMDocument $any
     * @return \Models\Docdata\StructType\PaymentResponse
     */
    public function setAny(\DOMDocument $any = null)
    {
        $this->any = $any;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Models\Docdata\StructType\PaymentResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
