<?php

namespace Models\Docdata\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for salesPerson StructType
 * @subpackage Structs
 */
class SalesPerson extends AbstractStructBase
{
    /**
     * The name
     * Meta informations extracted from the WSDL
     * - documentation: The name of the sales person.
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \Models\Docdata\StructType\Name
     */
    public $name;
    /**
     * Constructor method for salesPerson
     * @uses SalesPerson::setName()
     * @param \Models\Docdata\StructType\Name $name
     */
    public function __construct(\Models\Docdata\StructType\Name $name = null)
    {
        $this
            ->setName($name);
    }
    /**
     * Get name value
     * @return \Models\Docdata\StructType\Name
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param \Models\Docdata\StructType\Name $name
     * @return \Models\Docdata\StructType\SalesPerson
     */
    public function setName(\Models\Docdata\StructType\Name $name = null)
    {
        $this->name = $name;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Models\Docdata\StructType\SalesPerson
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
