<?php

namespace Models\Docdata\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for startErrors StructType
 * @subpackage Structs
 */
class StartErrors extends AbstractStructBase
{
    /**
     * The error
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \Models\Docdata\StructType\Error[]
     */
    public $error;
    /**
     * The any
     * @var \DOMDocument
     */
    public $any;
    /**
     * Constructor method for startErrors
     * @uses StartErrors::setError()
     * @uses StartErrors::setAny()
     * @param \Models\Docdata\StructType\Error[] $error
     * @param \DOMDocument $any
     */
    public function __construct(array $error = array(), \DOMDocument $any = null)
    {
        $this
            ->setError($error)
            ->setAny($any);
    }
    /**
     * Get error value
     * @return \Models\Docdata\StructType\Error[]
     */
    public function getError()
    {
        return $this->error;
    }
    /**
     * Set error value
     * @throws \InvalidArgumentException
     * @param \Models\Docdata\StructType\Error[] $error
     * @return \Models\Docdata\StructType\StartErrors
     */
    public function setError(array $error = array())
    {
        foreach ($error as $startErrorsErrorItem) {
            // validation for constraint: itemType
            if (!$startErrorsErrorItem instanceof \Models\Docdata\StructType\Error) {
                throw new \InvalidArgumentException(sprintf('The error property can only contain items of \Models\Docdata\StructType\Error, "%s" given', is_object($startErrorsErrorItem) ? get_class($startErrorsErrorItem) : gettype($startErrorsErrorItem)), __LINE__);
            }
        }
        $this->error = $error;
        return $this;
    }
    /**
     * Add item to error value
     * @throws \InvalidArgumentException
     * @param \Models\Docdata\StructType\Error $item
     * @return \Models\Docdata\StructType\StartErrors
     */
    public function addToError(\Models\Docdata\StructType\Error $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Models\Docdata\StructType\Error) {
            throw new \InvalidArgumentException(sprintf('The error property can only contain items of \Models\Docdata\StructType\Error, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->error[] = $item;
        return $this;
    }
    /**
     * Get any value
     * @uses \DOMDocument::loadXML()
     * @uses \DOMDocument::hasChildNodes()
     * @uses \DOMDocument::saveXML()
     * @uses \DOMNode::item()
     * @uses \Models\Docdata\StructType\StartErrors::setAny()
     * @param bool $asString true: returns XML string, false: returns \DOMDocument
     * @return \DOMDocument|null
     */
    public function getAny($asString = true)
    {
        if (!empty($this->any) && !($this->any instanceof \DOMDocument)) {
            $dom = new \DOMDocument('1.0', 'UTF-8');
            $dom->formatOutput = true;
            if ($dom->loadXML($this->any)) {
                $this->setAny($dom);
            }
            unset($dom);
        }
        return ($asString && ($this->any instanceof \DOMDocument) && $this->any->hasChildNodes()) ? $this->any->saveXML($this->any->childNodes->item(0)) : $this->any;
    }
    /**
     * Set any value
     * @param \DOMDocument $any
     * @return \Models\Docdata\StructType\StartErrors
     */
    public function setAny(\DOMDocument $any = null)
    {
        $this->any = $any;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Models\Docdata\StructType\StartErrors
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
