<?php

namespace Models\Docdata\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for statusSuccess StructType
 * @subpackage Structs
 */
class StatusSuccess extends AbstractStructBase
{
    /**
     * The success
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \Models\Docdata\StructType\Success
     */
    public $success;
    /**
     * The report
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \Models\Docdata\StructType\StatusReport
     */
    public $report;
    /**
     * The any
     * @var \DOMDocument
     */
    public $any;
    /**
     * Constructor method for statusSuccess
     * @uses StatusSuccess::setSuccess()
     * @uses StatusSuccess::setReport()
     * @uses StatusSuccess::setAny()
     * @param \Models\Docdata\StructType\Success $success
     * @param \Models\Docdata\StructType\StatusReport $report
     * @param \DOMDocument $any
     */
    public function __construct(\Models\Docdata\StructType\Success $success = null, \Models\Docdata\StructType\StatusReport $report = null, \DOMDocument $any = null)
    {
        $this
            ->setSuccess($success)
            ->setReport($report)
            ->setAny($any);
    }
    /**
     * Get success value
     * @return \Models\Docdata\StructType\Success
     */
    public function getSuccess()
    {
        return $this->success;
    }
    /**
     * Set success value
     * @param \Models\Docdata\StructType\Success $success
     * @return \Models\Docdata\StructType\StatusSuccess
     */
    public function setSuccess(\Models\Docdata\StructType\Success $success = null)
    {
        $this->success = $success;
        return $this;
    }
    /**
     * Get report value
     * @return \Models\Docdata\StructType\StatusReport
     */
    public function getReport()
    {
        return $this->report;
    }
    /**
     * Set report value
     * @param \Models\Docdata\StructType\StatusReport $report
     * @return \Models\Docdata\StructType\StatusSuccess
     */
    public function setReport(\Models\Docdata\StructType\StatusReport $report = null)
    {
        $this->report = $report;
        return $this;
    }
    /**
     * Get any value
     * @uses \DOMDocument::loadXML()
     * @uses \DOMDocument::hasChildNodes()
     * @uses \DOMDocument::saveXML()
     * @uses \DOMNode::item()
     * @uses \Models\Docdata\StructType\StatusSuccess::setAny()
     * @param bool $asString true: returns XML string, false: returns \DOMDocument
     * @return \DOMDocument|null
     */
    public function getAny($asString = true)
    {
        if (!empty($this->any) && !($this->any instanceof \DOMDocument)) {
            $dom = new \DOMDocument('1.0', 'UTF-8');
            $dom->formatOutput = true;
            if ($dom->loadXML($this->any)) {
                $this->setAny($dom);
            }
            unset($dom);
        }
        return ($asString && ($this->any instanceof \DOMDocument) && $this->any->hasChildNodes()) ? $this->any->saveXML($this->any->childNodes->item(0)) : $this->any;
    }
    /**
     * Set any value
     * @param \DOMDocument $any
     * @return \Models\Docdata\StructType\StatusSuccess
     */
    public function setAny(\DOMDocument $any = null)
    {
        $this->any = $any;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Models\Docdata\StructType\StatusSuccess
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
